package cse;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

import polyglot.frontend.CyclicDependencyException;
import polyglot.frontend.JLScheduler;
import polyglot.frontend.Job;
import polyglot.frontend.Scheduler;
import polyglot.frontend.goals.EmptyGoal;
import polyglot.frontend.goals.Goal;
import polyglot.frontend.goals.VisitorGoal;
import polyglot.util.InternalCompilerError;
import cse.ExtensionInfo;
import cse.visit.AssignOneDetector;
import cse.visit.AssignOneConverter;


public class Hw1Scheduler extends JLScheduler 
{
	protected Hw1Scheduler (ExtensionInfo extInfo) 
	{
        super(extInfo);
    }
	
	
    public Goal AssignOneExprsDetected (Job job) 
    {
        Goal g = internGoal(new VisitorGoal(job, new AssignOneDetector(job)));
        try { g.addPrerequisiteGoal(TypeChecked(job), this); }
        catch (CyclicDependencyException e) { throw new InternalCompilerError(e); }        

        return internGoal(g);
    }
    
    public Goal AssignOneExprsConverted (Job job)
    {
    	Goal g = internGoal(new VisitorGoal(job, new AssignOneConverter(job)));
    	try { g.addPrerequisiteGoal(AssignOneExprsDetected(job), this); }
    	catch (CyclicDependencyException e) { throw new InternalCompilerError(e); }        

    	return internGoal(g);    	
    }
	
	
    // make CommonExprsRemoved as a prerequisite for the Serialized goal
    // (Serialized is a standard goal in the compiler)
    @Override
    public Goal Serialized (Job job) 
    {	
		Goal g = null;
		g = internGoal(new EmptyGoal(job, "empty goal")
		{
			@Override
			public Collection<Goal> prerequisiteGoals (Scheduler scheduler) 
			{
				List<Goal> l = new ArrayList<Goal>();
				l.addAll(super.prerequisiteGoals(scheduler));

				l.add(AssignOneExprsConverted(job));
				return l;
			}
		});
           
        return g;
    }
}
