package cse.visit;

import polyglot.ast.Assign;
import polyglot.ast.IntLit;
import polyglot.ast.Node;
import polyglot.ast.NodeFactory;
import polyglot.frontend.Job;
import polyglot.util.Position;
import polyglot.visit.NodeVisitor;
import cse.extension.AssignExt;

/**
 * A class that converts all = 1 expressions into = 42.
 * 
 * @author akcheung
 *
 */
public class AssignOneConverter extends NodeVisitor
{
	protected NodeFactory nf;
	
	public AssignOneConverter (Job job)
	{
		super(job.extensionInfo().nodeFactory().lang());
		this.nf = job.extensionInfo().nodeFactory();
	}
	
	/**
	 * Return a new AST node (expression, statement, statement blocks, etc) as needed.
	 */
	@Override
	public Node leave (Node old, Node n, NodeVisitor v)
	{
		Node r = n;
		if (n instanceof Assign)
		{
			Assign assign = (Assign)n;
			AssignExt ext = (AssignExt)assign.ext();

			if (ext.assignToOne())
				r = assign.right(nf.IntLit(Position.compilerGenerated(), IntLit.INT, 42));
		}
		
		return r;
	}
}
